// Addon.h   Addon file for Wil 5.0 AddOns

typedef LPVOID LPBDS;                  // not really
typedef LPVOID LPRESULTVAR;            // not really
typedef LONG (FARPASCAL * DLLSERVICES) (HGLOBAL, WORD, LPSTR, LPSTR, int, DWORD);

typedef struct
{
  LPBDS       lpbdsptr;                // pointer to lpBDS (internal use)
  LPRESULTVAR lprvptr;                 // WIL resultvar (internal use)
  DWORD       dwLevel;                 // feature interface level
  DWORD       dwSize;                  // size of the structure
  DLLSERVICES lpfnDllServices;         // address of DLLServices function
  HGLOBAL     hBatData;                // buffer pointed to by lpBDS
} VIPERSTRUCT, FAR *LPVIPERSTRUCT;

typedef int FAR PASCAL AddOnCallback (int,LONG,LPSTR,BOOL,LONG,LPSTR);
typedef AddOnCallback FAR *lpAddOnCallback;

#define VARTYPE_UNDEF       0          // These are bitmapped, var can be both
#define VARTYPE_INT         1          // Numeric and string, must check bits
#define VARTYPE_STRING      2
#define VARTYPE_FILE        5          // FILE and INT bits set
#define VARTYPE_OLEOBJECT  17          // OLE AND INT bits set
#define VARTYPE_FLOATNUM   32          // floating point
#define VARTYPE_BINARY     65          // BINARY and INT bits set
#define VARTYPE_ARRAY     256          // an array

typedef struct vipervariable
{
  double  flt;                         // 8-byte floating point number
  LONG    x;                           // if int variable, value is here
  int     inittype;                    // 0=uninitialized 1=int 2=string 3=both  yes can have both sometimes
  union
  {
    LPSTR lpstr;                       // pointer to string in string table
    DWORD handle;                      // handle for miscellaneous object types
  };
} vipervar, FAR *LPVIPERVAR;




typedef int FAR PASCAL ViperCallback (int,LONG,LPVIPERSTRUCT,LPVIPERVAR);
typedef ViperCallback FAR *LPVIPERCALLBACK;




#ifdef WIN32
#define DllExport   __declspec(dllexport)
DllExport LONG
#else
LONG
#endif

FAR PASCAL WILExtender2(HWND,
                          HINSTANCE,
                          LONG,
                          short,
                          LPVIPERCALLBACK,
                          LPVIPERSTRUCT,
                          LPLONG,
                          LPVIPERVAR,
                          LONG,
                          LPVIPERVAR);

#ifdef WIN32
#define DllExport   __declspec(dllexport)
DllExport LONG
#else
LONG
#endif

FAR PASCAL WILExtenderQuery(short,
                            LPVOID,
                            LONG);

#define COMMEXT_WILSON  0x30030105L


//-------------------------------------------------------------------
// MISC. DEFINITIONS
//-------------------------------------------------------------------
#define FUNCTION        2
#define CONSTANT        3



#define RESULT_SUCCESS         0

//-------------------------------------------------------------------
//==== DELIMSIZE IS DEFINED BY INTERPRETER, DON'T CHANGE THIS! ======
//-------------------------------------------------------------------
#define DELIMSIZE  30
#define KTDELIMSIZE  30                // Gives us 30 character function names. NO modify


//-------------------------------------------------------------------
// COMMAND EXTENSION STRUCTURES
//-------------------------------------------------------------------



typedef struct tableinfo
{
  LONG    ident;                       // delimindex - must be consecutive!!!!!!
  LONG    type;                        // 2=FUNCTION 3=CONSTANT 4=COMMAND
  __int64 ulMask;                      // 64-bit mask (16 params, 4 bits each)
  LONG    param1;                      // (funct ? hi(reserved) lo(num-args))   (constant ? value)
  short   size;                        // length of function name
  char    delim[KTDELIMSIZE + 1];      // funct/const name - must be lowercase!
} tablestruct, FAR *LPTABLESTRUCT;
